// ASCIIChart.cpp : implementation file
//

#include "stdafx.h"
#include "forge.h"
#include "ASCIIChart.h"
#include "mainfrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CASCIIChart dialog


CASCIIChart::CASCIIChart(CWnd* pParent /*=NULL*/)
	: CDialog(CASCIIChart::IDD, pParent)
{
	//{{AFX_DATA_INIT(CASCIIChart)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CASCIIChart::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CASCIIChart)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CASCIIChart, CDialog)
	//{{AFX_MSG_MAP(CASCIIChart)
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CASCIIChart message handlers

void CASCIIChart::AddColumn(int index, LPCTSTR text)
{
	CListCtrl	*list = (CListCtrl *)GetDlgItem( IDC_LIST );
	ASSERT( list );

	list->InsertColumn( index, text );

	if (index==3)
		list->SetColumnWidth( index, list->GetStringWidth( text ) * 4 );
	else
		list->SetColumnWidth( index, list->GetStringWidth( text ) * 2 );
}

void CASCIIChart::AddItem(int i, LPCTSTR i1, LPCTSTR i2, LPCTSTR i3, LPCTSTR i4)
{
	CListCtrl	*list = (CListCtrl *)GetDlgItem( IDC_LIST );
	ASSERT( list );


	LV_ITEM		lvi;

	lvi.mask			=	LVIF_TEXT;
	lvi.iItem			=	0;
	lvi.iSubItem		=	0;
	lvi.pszText			=	(LPSTR)i1;
	list->InsertItem( &lvi );
	lvi.iItem = i;	lvi.iSubItem = 1; lvi.pszText = (LPSTR)i2; list->SetItem( &lvi );
	lvi.iItem = i;	lvi.iSubItem = 2; lvi.pszText = (LPSTR)i3; list->SetItem( &lvi );
	lvi.iItem = i;	lvi.iSubItem = 3; lvi.pszText = (LPSTR)i4; list->SetItem( &lvi );
}

BOOL CASCIIChart::OnInitDialog() 
{
	CDialog::OnInitDialog();

	AddColumn( 0, _T("Dec") );
	AddColumn( 1, _T("Hex") );
	AddColumn( 2, _T("Char") );
	AddColumn( 3, _T("Description") );

	AddItem(   0, _T("   0 "), _T(" 00 "), _T("   "), _T(" NUL Null character ") );
	AddItem(   1, _T("   1 "), _T(" 01 "), _T("   "), _T(" SOH Start of Header ") );
	AddItem(   2, _T("   2 "), _T(" 02 "), _T("   "), _T(" STX Start of Text ") );
	AddItem(   3, _T("   3 "), _T(" 03 "), _T("   "), _T(" ETX End of Text ") );
	AddItem(   4, _T("   4 "), _T(" 04 "), _T("   "), _T(" EOT End of Transmission ") );
	AddItem(   5, _T("   5 "), _T(" 05 "), _T("   "), _T(" ENQ Enquiry ") );
	AddItem(   6, _T("   6 "), _T(" 06 "), _T("   "), _T(" ACK Acknowledge ") );
	AddItem(   7, _T("   7 "), _T(" 07 "), _T("   "), _T(" BEL Bell ") );
	AddItem(   8, _T("   8 "), _T(" 08 "), _T("   "), _T(" BS  Backspace ") );
	AddItem(   9, _T("   9 "), _T(" 09 "), _T("   "), _T(" HT  Horizontal Tab ") );
	AddItem(  10, _T("  10 "), _T(" 0A "), _T("   "), _T(" LF  LineFeed ") );
	AddItem(  11, _T("  11 "), _T(" 0B "), _T("   "), _T(" VT  Vertical Tab ") );
	AddItem(  12, _T("  12 "), _T(" 0C "), _T("   "), _T(" FF  Form Feed ") );
	AddItem(  13, _T("  13 "), _T(" 0D "), _T("   "), _T(" CR  Carraige Return ") );
	AddItem(  14, _T("  14 "), _T(" 0E "), _T("   "), _T(" SO  Shift Out ") );
	AddItem(  15, _T("  15 "), _T(" 0F "), _T("   "), _T(" SI  Shift In ") );
	AddItem(  16, _T("  16 "), _T(" 10 "), _T("   "), _T(" DLE Data Link Escape ") );
	AddItem(  17, _T("  17 "), _T(" 11 "), _T("   "), _T(" DC1 Device Control 1 ") );
	AddItem(  18, _T("  18 "), _T(" 12 "), _T("   "), _T(" DC2 Device Control 2 ") );
	AddItem(  19, _T("  19 "), _T(" 13 "), _T("   "), _T(" DC3 Device Control 3 ") );
	AddItem(  20, _T("  20 "), _T(" 14 "), _T("   "), _T(" DC4 Device Control 4 ") );
	AddItem(  21, _T("  21 "), _T(" 15 "), _T("   "), _T(" NAK Negative Acknowledge ") );
	AddItem(  22, _T("  22 "), _T(" 16 "), _T("   "), _T(" SYN Synchronous Idle ") );
	AddItem(  23, _T("  23 "), _T(" 17 "), _T("   "), _T(" ETB End transmission Block ") );
	AddItem(  24, _T("  24 "), _T(" 18 "), _T("   "), _T(" CAN Cancel ") );
	AddItem(  25, _T("  25 "), _T(" 19 "), _T("   "), _T(" EM  End of Medium ") );
	AddItem(  26, _T("  26 "), _T(" 1A "), _T("   "), _T(" SUB Subsititute ") );
	AddItem(  27, _T("  27 "), _T(" 1B "), _T("   "), _T(" ESC Escape ") );
	AddItem(  28, _T("  28 "), _T(" 1C "), _T("   "), _T(" FS  File Seperator ") );
	AddItem(  29, _T("  29 "), _T(" 1D "), _T("   "), _T(" GS  Group Seperator ") );
	AddItem(  30, _T("  30 "), _T(" 1E "), _T("   "), _T(" RS  Record Seperator ") );
	AddItem(  31, _T("  31 "), _T(" 1F "), _T("   "), _T(" US  Unit Seperator ") );
	AddItem(  32, _T("  32 "), _T(" 20 "), _T("   "), _T(" Space Character ") );
	AddItem(  33, _T("  33 "), _T(" 21 "), _T(" ! "), _T(" Printable ASCII ") );
	AddItem(  34, _T("  34 "), _T(" 22 "), _T(" \" "), _T(" Printable ASCII ") );
	AddItem(  35, _T("  35 "), _T(" 23 "), _T(" # "), _T(" Printable ASCII ") );
	AddItem(  36, _T("  36 "), _T(" 24 "), _T(" $ "), _T(" Printable ASCII ") );
	AddItem(  37, _T("  37 "), _T(" 25 "), _T(" % "), _T(" Printable ASCII ") );
	AddItem(  38, _T("  38 "), _T(" 26 "), _T(" & "), _T(" Printable ASCII ") );
	AddItem(  39, _T("  39 "), _T(" 27 "), _T(" ' "), _T(" Printable ASCII ") );
	AddItem(  40, _T("  40 "), _T(" 28 "), _T(" ( "), _T(" Printable ASCII ") );
	AddItem(  41, _T("  41 "), _T(" 29 "), _T(" ) "), _T(" Printable ASCII ") );
	AddItem(  42, _T("  42 "), _T(" 2A "), _T(" * "), _T(" Printable ASCII ") );
	AddItem(  43, _T("  43 "), _T(" 2B "), _T(" + "), _T(" Printable ASCII ") );
	AddItem(  44, _T("  44 "), _T(" 2C "), _T(" , "), _T(" Printable ASCII ") );
	AddItem(  45, _T("  45 "), _T(" 2D "), _T(" - "), _T(" Printable ASCII ") );
	AddItem(  46, _T("  46 "), _T(" 2E "), _T(" . "), _T(" Printable ASCII ") );
	AddItem(  47, _T("  47 "), _T(" 2F "), _T(" / "), _T(" Printable ASCII ") );
	AddItem(  48, _T("  48 "), _T(" 30 "), _T(" 0 "), _T(" Printable ASCII ") );
	AddItem(  49, _T("  49 "), _T(" 31 "), _T(" 1 "), _T(" Printable ASCII ") );
	AddItem(  50, _T("  50 "), _T(" 32 "), _T(" 2 "), _T(" Printable ASCII ") );
	AddItem(  51, _T("  51 "), _T(" 33 "), _T(" 3 "), _T(" Printable ASCII ") );
	AddItem(  52, _T("  52 "), _T(" 34 "), _T(" 4 "), _T(" Printable ASCII ") );
	AddItem(  53, _T("  53 "), _T(" 35 "), _T(" 5 "), _T(" Printable ASCII ") );
	AddItem(  54, _T("  54 "), _T(" 36 "), _T(" 6 "), _T(" Printable ASCII ") );
	AddItem(  55, _T("  55 "), _T(" 37 "), _T(" 7 "), _T(" Printable ASCII ") );
	AddItem(  56, _T("  56 "), _T(" 38 "), _T(" 8 "), _T(" Printable ASCII ") );
	AddItem(  57, _T("  57 "), _T(" 39 "), _T(" 9 "), _T(" Printable ASCII ") );
	AddItem(  58, _T("  58 "), _T(" 3A "), _T(" : "), _T(" Printable ASCII ") );
	AddItem(  59, _T("  59 "), _T(" 3B "), _T(" ; "), _T(" Printable ASCII ") );
	AddItem(  60, _T("  60 "), _T(" 3C "), _T(" < "), _T(" Printable ASCII ") );
	AddItem(  61, _T("  61 "), _T(" 3D "), _T(" = "), _T(" Printable ASCII ") );
	AddItem(  62, _T("  62 "), _T(" 3E "), _T(" > "), _T(" Printable ASCII ") );
	AddItem(  63, _T("  63 "), _T(" 3F "), _T(" ? "), _T(" Printable ASCII ") );
	AddItem(  64, _T("  64 "), _T(" 40 "), _T(" @ "), _T(" Printable ASCII ") );
	AddItem(  65, _T("  65 "), _T(" 41 "), _T(" A "), _T(" Printable ASCII ") );
	AddItem(  66, _T("  66 "), _T(" 42 "), _T(" B "), _T(" Printable ASCII ") );
	AddItem(  67, _T("  67 "), _T(" 43 "), _T(" C "), _T(" Printable ASCII ") );
	AddItem(  68, _T("  68 "), _T(" 44 "), _T(" D "), _T(" Printable ASCII ") );
	AddItem(  69, _T("  69 "), _T(" 45 "), _T(" E "), _T(" Printable ASCII ") );
	AddItem(  70, _T("  70 "), _T(" 46 "), _T(" F "), _T(" Printable ASCII ") );
	AddItem(  71, _T("  71 "), _T(" 47 "), _T(" G "), _T(" Printable ASCII ") );
	AddItem(  72, _T("  72 "), _T(" 48 "), _T(" H "), _T(" Printable ASCII ") );
	AddItem(  73, _T("  73 "), _T(" 49 "), _T(" I "), _T(" Printable ASCII ") );
	AddItem(  74, _T("  74 "), _T(" 4A "), _T(" J "), _T(" Printable ASCII ") );
	AddItem(  75, _T("  75 "), _T(" 4B "), _T(" K "), _T(" Printable ASCII ") );
	AddItem(  76, _T("  76 "), _T(" 4C "), _T(" L "), _T(" Printable ASCII ") );
	AddItem(  77, _T("  77 "), _T(" 4D "), _T(" M "), _T(" Printable ASCII ") );
	AddItem(  78, _T("  78 "), _T(" 4E "), _T(" N "), _T(" Printable ASCII ") );
	AddItem(  79, _T("  79 "), _T(" 4F "), _T(" O "), _T(" Printable ASCII ") );
	AddItem(  80, _T("  80 "), _T(" 50 "), _T(" P "), _T(" Printable ASCII ") );
	AddItem(  81, _T("  81 "), _T(" 51 "), _T(" Q "), _T(" Printable ASCII ") );
	AddItem(  82, _T("  82 "), _T(" 52 "), _T(" R "), _T(" Printable ASCII ") );
	AddItem(  83, _T("  83 "), _T(" 53 "), _T(" S "), _T(" Printable ASCII ") );
	AddItem(  84, _T("  84 "), _T(" 54 "), _T(" T "), _T(" Printable ASCII ") );
	AddItem(  85, _T("  85 "), _T(" 55 "), _T(" U "), _T(" Printable ASCII ") );
	AddItem(  86, _T("  86 "), _T(" 56 "), _T(" V "), _T(" Printable ASCII ") );
	AddItem(  87, _T("  87 "), _T(" 57 "), _T(" W "), _T(" Printable ASCII ") );
	AddItem(  88, _T("  88 "), _T(" 58 "), _T(" X "), _T(" Printable ASCII ") );
	AddItem(  89, _T("  89 "), _T(" 59 "), _T(" Y "), _T(" Printable ASCII ") );
	AddItem(  90, _T("  90 "), _T(" 5A "), _T(" Z "), _T(" Printable ASCII ") );
	AddItem(  91, _T("  91 "), _T(" 5B "), _T(" [ "), _T(" Printable ASCII ") );
	AddItem(  92, _T("  92 "), _T(" 5C "), _T(" \\ "), _T(" Printable ASCII ") );
	AddItem(  93, _T("  93 "), _T(" 5D "), _T(" ] "), _T(" Printable ASCII ") );
	AddItem(  94, _T("  94 "), _T(" 5E "), _T(" ^ "), _T(" Printable ASCII ") );
	AddItem(  95, _T("  95 "), _T(" 5F "), _T(" _ "), _T(" Printable ASCII ") );
	AddItem(  96, _T("  96 "), _T(" 60 "), _T(" ` "), _T(" Printable ASCII ") );
	AddItem(  97, _T("  97 "), _T(" 61 "), _T(" a "), _T(" Printable ASCII ") );
	AddItem(  98, _T("  98 "), _T(" 62 "), _T(" b "), _T(" Printable ASCII ") );
	AddItem(  99, _T("  99 "), _T(" 63 "), _T(" c "), _T(" Printable ASCII ") );
	AddItem( 100, _T(" 100 "), _T(" 64 "), _T(" d "), _T(" Printable ASCII ") );
	AddItem( 101, _T(" 101 "), _T(" 65 "), _T(" e "), _T(" Printable ASCII ") );
	AddItem( 102, _T(" 102 "), _T(" 66 "), _T(" f "), _T(" Printable ASCII ") );
	AddItem( 103, _T(" 103 "), _T(" 67 "), _T(" g "), _T(" Printable ASCII ") );
	AddItem( 104, _T(" 104 "), _T(" 68 "), _T(" h "), _T(" Printable ASCII ") );
	AddItem( 105, _T(" 105 "), _T(" 69 "), _T(" i "), _T(" Printable ASCII ") );
	AddItem( 106, _T(" 106 "), _T(" 6A "), _T(" j "), _T(" Printable ASCII ") );
	AddItem( 107, _T(" 107 "), _T(" 6B "), _T(" k "), _T(" Printable ASCII ") );
	AddItem( 108, _T(" 108 "), _T(" 6C "), _T(" l "), _T(" Printable ASCII ") );
	AddItem( 109, _T(" 109 "), _T(" 6D "), _T(" m "), _T(" Printable ASCII ") );
	AddItem( 110, _T(" 110 "), _T(" 6E "), _T(" n "), _T(" Printable ASCII ") );
	AddItem( 111, _T(" 111 "), _T(" 6F "), _T(" o "), _T(" Printable ASCII ") );
	AddItem( 112, _T(" 112 "), _T(" 70 "), _T(" p "), _T(" Printable ASCII ") );
	AddItem( 113, _T(" 113 "), _T(" 71 "), _T(" q "), _T(" Printable ASCII ") );
	AddItem( 114, _T(" 114 "), _T(" 72 "), _T(" r "), _T(" Printable ASCII ") );
	AddItem( 115, _T(" 115 "), _T(" 73 "), _T(" s "), _T(" Printable ASCII ") );
	AddItem( 116, _T(" 116 "), _T(" 74 "), _T(" t "), _T(" Printable ASCII ") );
	AddItem( 117, _T(" 117 "), _T(" 75 "), _T(" u "), _T(" Printable ASCII ") );
	AddItem( 118, _T(" 118 "), _T(" 76 "), _T(" v "), _T(" Printable ASCII ") );
	AddItem( 119, _T(" 119 "), _T(" 77 "), _T(" w "), _T(" Printable ASCII ") );
	AddItem( 120, _T(" 120 "), _T(" 78 "), _T(" x "), _T(" Printable ASCII ") );
	AddItem( 121, _T(" 121 "), _T(" 79 "), _T(" y "), _T(" Printable ASCII ") );
	AddItem( 122, _T(" 122 "), _T(" 7A "), _T(" z "), _T(" Printable ASCII ") );
	AddItem( 123, _T(" 123 "), _T(" 7B "), _T(" { "), _T(" Printable ASCII ") );
	AddItem( 124, _T(" 124 "), _T(" 7C "), _T(" | "), _T(" Printable ASCII ") );
	AddItem( 125, _T(" 125 "), _T(" 7D "), _T(" } "), _T(" Printable ASCII ") );
	AddItem( 126, _T(" 126 "), _T(" 7E "), _T(" ~ "), _T(" Printable ASCII ") );
	AddItem( 127, _T(" 127 "), _T(" 7F "), _T("   "), _T(" DEL Delete ") );
	AddItem( 128, _T(" 128 "), _T(" 80 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 129, _T(" 129 "), _T(" 81 "), _T("   "), _T(" Graphic Character ") );
 	AddItem( 130, _T(" 130 "), _T(" 82 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 131, _T(" 131 "), _T(" 83 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 132, _T(" 132 "), _T(" 84 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 133, _T(" 133 "), _T(" 85 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 134, _T(" 134 "), _T(" 86 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 135, _T(" 135 "), _T(" 87 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 136, _T(" 136 "), _T(" 88 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 137, _T(" 137 "), _T(" 89 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 138, _T(" 138 "), _T(" 8A "), _T("   "), _T(" Graphic Character ") );
	AddItem( 139, _T(" 139 "), _T(" 8B "), _T("   "), _T(" Graphic Character ") );
	AddItem( 140, _T(" 140 "), _T(" 8C "), _T("   "), _T(" Graphic Character ") );
	AddItem( 141, _T(" 141 "), _T(" 8D "), _T("   "), _T(" Graphic Character ") );
	AddItem( 142, _T(" 142 "), _T(" 8E "), _T("   "), _T(" Graphic Character ") );
	AddItem( 143, _T(" 143 "), _T(" 8F "), _T("   "), _T(" Graphic Character ") );
	AddItem( 144, _T(" 144 "), _T(" 90 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 145, _T(" 145 "), _T(" 91 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 146, _T(" 146 "), _T(" 92 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 147, _T(" 147 "), _T(" 93 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 148, _T(" 148 "), _T(" 94 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 149, _T(" 149 "), _T(" 95 "), _T("   "), _T(" Graphic Character ") );
 	AddItem( 150, _T(" 150 "), _T(" 96 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 151, _T(" 151 "), _T(" 97 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 152, _T(" 152 "), _T(" 98 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 153, _T(" 153 "), _T(" 99 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 154, _T(" 154 "), _T(" 9A "), _T("   "), _T(" Graphic Character ") );
	AddItem( 155, _T(" 155 "), _T(" 9B "), _T("   "), _T(" Graphic Character ") );
	AddItem( 156, _T(" 156 "), _T(" 9C "), _T("   "), _T(" Graphic Character ") );
	AddItem( 157, _T(" 157 "), _T(" 9D "), _T("   "), _T(" Graphic Character ") );
	AddItem( 158, _T(" 158 "), _T(" 9E "), _T("   "), _T(" Graphic Character ") );
	AddItem( 159, _T(" 159 "), _T(" 9F "), _T("   "), _T(" Graphic Character ") );
 	AddItem( 160, _T(" 160 "), _T(" A0 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 161, _T(" 161 "), _T(" A1 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 162, _T(" 162 "), _T(" A2 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 163, _T(" 163 "), _T(" A3 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 164, _T(" 164 "), _T(" A4 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 165, _T(" 165 "), _T(" A5 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 166, _T(" 166 "), _T(" A6 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 167, _T(" 167 "), _T(" A7 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 168, _T(" 168 "), _T(" A8 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 169, _T(" 169 "), _T(" A9 "), _T("   "), _T(" Graphic Character ") );
 	AddItem( 170, _T(" 170 "), _T(" AA "), _T("   "), _T(" Graphic Character ") );
	AddItem( 171, _T(" 171 "), _T(" AB "), _T("   "), _T(" Graphic Character ") );
	AddItem( 172, _T(" 172 "), _T(" AC "), _T("   "), _T(" Graphic Character ") );
	AddItem( 173, _T(" 173 "), _T(" AD "), _T("   "), _T(" Graphic Character ") );
	AddItem( 174, _T(" 174 "), _T(" AE "), _T("   "), _T(" Graphic Character ") );
	AddItem( 175, _T(" 175 "), _T(" AF "), _T("   "), _T(" Graphic Character ") );
	AddItem( 176, _T(" 176 "), _T(" B0 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 177, _T(" 177 "), _T(" B1 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 178, _T(" 178 "), _T(" B2 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 179, _T(" 179 "), _T(" B3 "), _T("   "), _T(" Graphic Character ") );
 	AddItem( 180, _T(" 180 "), _T(" B4 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 181, _T(" 181 "), _T(" B5 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 182, _T(" 182 "), _T(" B6 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 183, _T(" 183 "), _T(" B7 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 184, _T(" 184 "), _T(" B8 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 185, _T(" 185 "), _T(" B9 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 186, _T(" 186 "), _T(" BA "), _T("   "), _T(" Graphic Character ") );
	AddItem( 187, _T(" 187 "), _T(" BB "), _T("   "), _T(" Graphic Character ") );
	AddItem( 188, _T(" 188 "), _T(" BC "), _T("   "), _T(" Graphic Character ") );
	AddItem( 189, _T(" 189 "), _T(" BD "), _T("   "), _T(" Graphic Character ") );
 	AddItem( 190, _T(" 190 "), _T(" BE "), _T("   "), _T(" Graphic Character ") );
	AddItem( 191, _T(" 191 "), _T(" BF "), _T("   "), _T(" Graphic Character ") );
	AddItem( 192, _T(" 192 "), _T(" C0 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 193, _T(" 193 "), _T(" C1 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 194, _T(" 194 "), _T(" C2 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 195, _T(" 195 "), _T(" C3 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 196, _T(" 196 "), _T(" C4 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 197, _T(" 197 "), _T(" C5 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 198, _T(" 198 "), _T(" C6 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 199, _T(" 199 "), _T(" C7 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 200, _T(" 200 "), _T(" C8 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 201, _T(" 201 "), _T(" C9 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 202, _T(" 202 "), _T(" CA "), _T("   "), _T(" Graphic Character ") );
	AddItem( 203, _T(" 203 "), _T(" CB "), _T("   "), _T(" Graphic Character ") );
	AddItem( 204, _T(" 204 "), _T(" CC "), _T("   "), _T(" Graphic Character ") );
	AddItem( 205, _T(" 205 "), _T(" CD "), _T("   "), _T(" Graphic Character ") );
	AddItem( 206, _T(" 206 "), _T(" CE "), _T("   "), _T(" Graphic Character ") );
	AddItem( 207, _T(" 207 "), _T(" CF "), _T("   "), _T(" Graphic Character ") );
	AddItem( 208, _T(" 208 "), _T(" D0 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 209, _T(" 209 "), _T(" D1 "), _T("   "), _T(" Graphic Character ") );
 	AddItem( 210, _T(" 210 "), _T(" D2 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 211, _T(" 211 "), _T(" D3 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 212, _T(" 212 "), _T(" D4 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 213, _T(" 213 "), _T(" D5 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 214, _T(" 214 "), _T(" D6 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 215, _T(" 215 "), _T(" D7 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 216, _T(" 216 "), _T(" D8 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 217, _T(" 217 "), _T(" D9 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 218, _T(" 218 "), _T(" DA "), _T("   "), _T(" Graphic Character ") );
	AddItem( 219, _T(" 219 "), _T(" DB "), _T("   "), _T(" Graphic Character ") );
 	AddItem( 220, _T(" 220 "), _T(" DC "), _T("   "), _T(" Graphic Character ") );
	AddItem( 221, _T(" 221 "), _T(" DD "), _T("   "), _T(" Graphic Character ") );
	AddItem( 222, _T(" 222 "), _T(" DE "), _T("   "), _T(" Graphic Character ") );
	AddItem( 223, _T(" 223 "), _T(" DF "), _T("   "), _T(" Graphic Character ") );
	AddItem( 224, _T(" 224 "), _T(" E0 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 225, _T(" 225 "), _T(" E1 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 226, _T(" 226 "), _T(" E2 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 227, _T(" 227 "), _T(" E3 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 228, _T(" 228 "), _T(" E4 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 229, _T(" 229 "), _T(" E5 "), _T("   "), _T(" Graphic Character ") );
 	AddItem( 230, _T(" 230 "), _T(" E6 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 231, _T(" 231 "), _T(" E7 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 232, _T(" 232 "), _T(" E8 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 233, _T(" 233 "), _T(" E9 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 234, _T(" 234 "), _T(" EA "), _T("   "), _T(" Graphic Character ") );
	AddItem( 235, _T(" 235 "), _T(" EB "), _T("   "), _T(" Graphic Character ") );
	AddItem( 236, _T(" 236 "), _T(" EC "), _T("   "), _T(" Graphic Character ") );
	AddItem( 237, _T(" 237 "), _T(" ED "), _T("   "), _T(" Graphic Character ") );
	AddItem( 238, _T(" 238 "), _T(" EE "), _T("   "), _T(" Graphic Character ") );
	AddItem( 239, _T(" 239 "), _T(" EF "), _T("   "), _T(" Graphic Character ") );
 	AddItem( 240, _T(" 240 "), _T(" F0 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 241, _T(" 241 "), _T(" F1 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 242, _T(" 242 "), _T(" F2 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 243, _T(" 243 "), _T(" F3 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 244, _T(" 244 "), _T(" F4 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 245, _T(" 245 "), _T(" F5 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 246, _T(" 246 "), _T(" F6 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 247, _T(" 247 "), _T(" F7 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 248, _T(" 248 "), _T(" F8 "), _T("   "), _T(" Graphic Character ") );
	AddItem( 249, _T(" 249 "), _T(" F9 "), _T("   "), _T(" Graphic Character ") );
 	AddItem( 250, _T(" 250 "), _T(" FA "), _T("   "), _T(" Graphic Character ") );
	AddItem( 251, _T(" 251 "), _T(" FB "), _T("   "), _T(" Graphic Character ") );
	AddItem( 252, _T(" 252 "), _T(" FC "), _T("   "), _T(" Graphic Character ") );
	AddItem( 253, _T(" 253 "), _T(" FD "), _T("   "), _T(" Graphic Character ") );
	AddItem( 254, _T(" 254 "), _T(" FE "), _T("   "), _T(" Graphic Character ") );
	AddItem( 255, _T(" 255 "), _T(" FF "), _T("   "), _T(" Graphic Character ") );

	ShowWindow(SW_NORMAL);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CASCIIChart::OnClose() 
{
	( (CMainFrame *)GetParent() )->m_dlgASCIIChart = NULL;	
	
	CDialog::OnClose();
}

void CASCIIChart::OnOK() 
{
	( (CMainFrame *)GetParent() )->m_dlgASCIIChart = NULL;	
	
	CDialog::OnOK();
}


