// BaseConvertor.cpp : implementation file
//

#include "stdafx.h"
#include "forge.h"
#include "BaseConvertor.h"
#include "mainfrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CBaseConvertor dialog


CBaseConvertor::CBaseConvertor(CWnd* pParent /*=NULL*/)
	: CDialog(CBaseConvertor::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBaseConvertor)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CBaseConvertor::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBaseConvertor)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CBaseConvertor, CDialog)
	//{{AFX_MSG_MAP(CBaseConvertor)
	ON_BN_CLICKED(IDC_BINARY, OnBinary)
	ON_BN_CLICKED(IDC_DECIMAL, OnDecimal)
	ON_BN_CLICKED(IDC_HEX, OnHex)
	ON_BN_CLICKED(IDC_OTHER, OnOther)
	ON_EN_CHANGE(IDC_OTHERBASE, OnChangeOtherbase)
	ON_WM_CLOSE()
	ON_EN_CHANGE(IDC_NUMBER, OnChangeNumber)
	ON_EN_KILLFOCUS(IDC_OTHERBASE, OnKillfocusOtherbase)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBaseConvertor message handlers

BOOL CBaseConvertor::OnInitDialog() 
{
	CDialog::OnInitDialog();
	ShowWindow(SW_NORMAL);
	SetDlgItemText( IDC_NUMBER, "0" );
	SetDlgItemText( IDC_OTHERBASE, "8" );
	OnDecimal();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CBaseConvertor::OnBinary() 
{
	// TODO: Add your control notification handler code here
	SetBase(IDC_BINARY);
}

void CBaseConvertor::OnDecimal() 
{
	// TODO: Add your control notification handler code here
	SetBase(IDC_DECIMAL);
}

void CBaseConvertor::OnHex() 
{
	// TODO: Add your control notification handler code here
	SetBase(IDC_HEX);
}

void CBaseConvertor::OnOther() 
{
	// TODO: Add your control notification handler code here
	SetBase(IDC_OTHER);
}

void CBaseConvertor::OnChangeOtherbase() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_CHANGE flag ORed into the lParam mask.
	
	// TODO: Add your control notification handler code here
	CString	cs;	GetDlgItemText( IDC_OTHERBASE, cs );
	int i = ToNumber( cs, 10 );
	if (i>1) SetBase( IDC_OTHER );
}

void CBaseConvertor::SetBase(int base)
{
	CWnd	*cw		=	GetDlgItem( IDC_OTHERBASE );

	cw->EnableWindow(FALSE);
	if ( base == IDC_BINARY )	CheckRadioButton( IDC_BINARY, IDC_OTHER, IDC_BINARY );
	if ( base == IDC_DECIMAL )	CheckRadioButton( IDC_BINARY, IDC_OTHER, IDC_DECIMAL );
	if ( base == IDC_HEX )	CheckRadioButton( IDC_BINARY, IDC_OTHER, IDC_HEX );
	if ( base == IDC_OTHER )
	{
		CheckRadioButton( IDC_BINARY, IDC_OTHER, IDC_OTHER );
		cw->EnableWindow(TRUE);
		cw->SetFocus();
	}

	SetCurrentValue(cv);
}



int CBaseConvertor::GetCurrentValue()
{
	return cv;
}

void CBaseConvertor::SetCurrentValue(int dw)
{
	CString	cs;	
	ToString( dw, cs, GetRadix() );
	SetDlgItemText( IDC_NUMBER, cs );
}

int CBaseConvertor::GetRadix()
{
	int	i;
	if ( IsDlgButtonChecked( IDC_BINARY ) ) return 2;
	if ( IsDlgButtonChecked( IDC_DECIMAL ) ) return 10;
	if ( IsDlgButtonChecked( IDC_HEX ) ) return 16;
	CString	cs;	GetDlgItemText( IDC_OTHERBASE, cs );
	i = ToNumber( cs, 10 );
	if (i>1) return i;
	else 
	{
//		::MessageBox( m_hWnd, _T("Badly formed radix"), _T("Error"), MB_OK | MB_ICONEXCLAMATION );
		return 10;
	}
}

BOOL CBaseConvertor::DestroyWindow() 
{
	return CDialog::DestroyWindow();
}

void CBaseConvertor::OnClose() 
{
	( (CMainFrame *)GetParent() )->m_dlgBaseConvertor = NULL;	
	
	CDialog::OnClose();
}

void CBaseConvertor::OnOK() 
{
	( (CMainFrame *)GetParent() )->m_dlgBaseConvertor = NULL;	
	
	CDialog::OnOK();
}

int digit( TCHAR t )
{
	int	i;

	i = (int) t;
	i-=48;
	if (i>9) i-=7;
	return i;
}

int CBaseConvertor::ToNumber(CString & cs, int radix)
{
	int		i = 0;
	int		acc = 0;

	int	l = cs.GetLength();

	if (l==0) return 0;

	if ( cs[0]=='+' ) { i++; }
	if ( cs[0]=='-' ) { i++; acc=-1; }


	while (i<l)
	{
		acc*=radix;
		acc+=::digit( cs[i++] );
	} 
	return acc;
}

TCHAR plusascii( int i )
{
	if (i>9) i+=7;
	i+=48;
	return (TCHAR)i;
}

void CBaseConvertor::ToString(int num, CString & cs, int radix)
{
	BOOL	bNeg;
	int		i;

	bNeg = (num<0);
	num=abs(num);

	if (num==0) cs="0";
	else
	{
		while (num)
		{
			cs=" "+cs;
			i = num%radix;
			num=num/radix;
			cs.SetAt(0,::plusascii(i));
		}
	}

	if (bNeg) cs="-"+cs;
}


void CBaseConvertor::OnChangeNumber() 
{
	CString cs;

	GetDlgItemText( IDC_NUMBER, cs );
	cv = ToNumber( cs, GetRadix() );
}

void CBaseConvertor::OnKillfocusOtherbase() 
{
	// TODO: Add your control notification handler code here
}
