// TSEPOS 1 1 1 //
// DebugMemoryView.cpp: implementation of the CDebugMemoryView class.
//
//////////////////////////////////////////////////////////////////////

#include <stdio.h>

#include "stdafx.h"
#include "forge.h"
#include "DebugMemoryView.h"

#include "MainFrm.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

IMPLEMENT_DYNAMIC(CDebugMemoryView, CSizingControlBar)

BEGIN_MESSAGE_MAP(CDebugMemoryView, CSizingControlBar)
	//{{AFX_MSG_MAP(CProjectWindow)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDebugMemoryView::CDebugMemoryView()
{
}

CDebugMemoryView::~CDebugMemoryView()
{
}

BOOL CDebugMemoryView::Create(LPCTSTR lpszWindowName, CWnd * pParentWnd, CSize sizeDefault, BOOL bHasGripper)
{
	CSizingControlBar::Create(lpszWindowName, pParentWnd, sizeDefault, bHasGripper, IDR_DEBUGMEMORYVIEW );

	m_list.Create( WS_CHILD | WS_VISIBLE | WS_BORDER | WS_HSCROLL | WS_VSCROLL , CRect(0,0,0,0), this, 1 );
	m_Font.CreatePointFont( 100, "Courier", NULL );
	m_list.SetFont(&m_Font);

	return TRUE;
}

void CDebugMemoryView::OnSize(UINT nType, int cx, int cy)
{
	if (m_list.m_hWnd)
	{
		m_list.MoveWindow( 0, 0, cx, cy );
	}
}

void CDebugMemoryView::OnReset()
{
	LoadState( _T("DEBUGMEMORYVIEW_PERM") );
}

void CDebugMemoryView::OnDebugFinished()
{
	RememberVisibility( IsWindowVisible() );
	SaveState( _T("DEBUGMEMORYVIEW_PERM") );
}

// mem points to memory dump in host space
// len is the length of said memory block
// VirtualAddress is the target base address
// ViewOffset it the TARGET ADDRESS we are interested in
// Width is the data view width (1,2 or 4 bytes)

void CDebugMemoryView::DisplayMemory(LPVOID mem, int len, int VirtualAddress, int ViewOffset, int Width )
{
	char	temp[256];
	CString	op;
	int		i;
	int		high = -1;
	CString	lf;

	m_list.ResetContent();

	unsigned char *p = (unsigned char *)mem;
	unsigned char *cp = p+len;

	// TODO Check memory addresses against buffer at CP (0==invalid) so i can do ???? for invalid sections.

	while (len>0)
	{
		if ( (ViewOffset>=VirtualAddress) && (ViewOffset<(VirtualAddress+16) ) ) high = m_list.GetCount();

		sprintf( temp, "%08X : ", (unsigned int)VirtualAddress );	op = (LPCTSTR)temp;
		
		switch( Width )
		{
		case 1:
			for (i=0;i<8;i++) { sprintf( temp, "%02X", *p++ ); op+=(LPCTSTR)temp; op+=' '; }
			op+=' ';
			for (i=0;i<8;i++) { sprintf( temp, "%02X", *p++ ); op+=(LPCTSTR)temp; op+=' '; }
			break;
		case 2:
			for (i=0;i<4;i++) { sprintf( temp, "%02X%02X", p[1], *p ); p+=2; op+=(LPCTSTR)temp; op+=' '; }
			op+=' ';
			for (i=0;i<4;i++) { sprintf( temp, "%02X%02X", p[1], *p ); p+=2; op+=(LPCTSTR)temp; op+=' '; }
			break;
		case 4:
			for (i=0;i<2;i++) { sprintf( temp, "%02X%02X%02X%02X", p[3], p[2], p[1], *p ); p+=4; op+=(LPCTSTR)temp; op+=' '; }
			op+=' ';
			for (i=0;i<2;i++) { sprintf( temp, "%02X%02X%02X%02X", p[3], p[2], p[1], *p ); p+=4; op+=(LPCTSTR)temp; op+=' '; }
			break;
		}

		p-=16;
		op+=' ';
		for (i=0;i<16;i++)
		{
			if ( isprint(*p) ) op+=(*p); else op+='.';
			p++;
		}

		len-=16;
		VirtualAddress+=16;
		if ( high != -1 ) { lf = op; high=-1; }

		m_list.AddString( op );
	}

	m_list.SelectString( high-1, lf );
}
