// TSEPOS 59 2 36 //
// DebugRegisterView.cpp: implementation of the CDebugRegisterView class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "forge.h"
#include "DebugRegisterView.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

IMPLEMENT_DYNAMIC(CDebugRegisterView, CSizingControlBar)

BEGIN_MESSAGE_MAP(CDebugRegisterView, CSizingControlBar)
	//{{AFX_MSG_MAP(CDebugRegisterView)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CDebugRegisterView::CDebugRegisterView()
{
	hThread = NULL;	
}

CDebugRegisterView::~CDebugRegisterView()
{

}

#define	REGKEY_WIDTH	48
#define	REGVAL_WIDTH	160
#define	REGVAL_HEIGHT	18
#define REGSTYLE	WS_CHILD | WS_VISIBLE

BOOL CDebugRegisterView::Create(LPCTSTR lpszWindowName, CWnd * pParentWnd, CSize sizeDefault, BOOL bHasGripper)
{
	CSizingControlBar::Create(lpszWindowName, pParentWnd, sizeDefault, bHasGripper, IDR_DEBUGREGISTERVIEW );
	m_Font.CreatePointFont( 100, "Courier", NULL );

	m_WndReg[0].Create( _T("EAX"), _T("00000000"), REGSTYLE, this, REGKEY_WIDTH, REGVAL_WIDTH, REGVAL_HEIGHT );
	m_WndReg[1].Create( _T("EBX"), _T("00000000"), REGSTYLE, this, REGKEY_WIDTH, REGVAL_WIDTH, REGVAL_HEIGHT );
	m_WndReg[2].Create( _T("ECX"), _T("00000000"), REGSTYLE, this, REGKEY_WIDTH, REGVAL_WIDTH, REGVAL_HEIGHT );
	m_WndReg[3].Create( _T("EDX"), _T("00000000"), REGSTYLE, this, REGKEY_WIDTH, REGVAL_WIDTH, REGVAL_HEIGHT );
	m_WndReg[4].Create( _T("ESI"), _T("00000000"), REGSTYLE, this, REGKEY_WIDTH, REGVAL_WIDTH, REGVAL_HEIGHT );
	m_WndReg[5].Create( _T("EDI"), _T("00000000"), REGSTYLE, this, REGKEY_WIDTH, REGVAL_WIDTH, REGVAL_HEIGHT );

	m_WndReg[6].Create( _T("EBP"), _T("00000000"), REGSTYLE, this, REGKEY_WIDTH, REGVAL_WIDTH, REGVAL_HEIGHT );
	m_WndReg[7].Create( _T("ESP"), _T("00000000"), REGSTYLE, this, REGKEY_WIDTH, REGVAL_WIDTH, REGVAL_HEIGHT );

	m_WndReg[8].Create(  _T("SegCS"), _T("00000000"), REGSTYLE, this, REGKEY_WIDTH, REGVAL_WIDTH, REGVAL_HEIGHT );
	m_WndReg[9].Create(  _T("SegDS"), _T("00000000"), REGSTYLE, this, REGKEY_WIDTH, REGVAL_WIDTH, REGVAL_HEIGHT );
	m_WndReg[10].Create( _T("SegES"), _T("00000000"), REGSTYLE, this, REGKEY_WIDTH, REGVAL_WIDTH, REGVAL_HEIGHT );
	m_WndReg[11].Create( _T("SegFS"), _T("00000000"), REGSTYLE, this, REGKEY_WIDTH, REGVAL_WIDTH, REGVAL_HEIGHT );
	m_WndReg[12].Create( _T("SegGS"), _T("00000000"), REGSTYLE, this, REGKEY_WIDTH, REGVAL_WIDTH, REGVAL_HEIGHT );
	m_WndReg[13].Create( _T("SegSS"), _T("00000000"), REGSTYLE, this, REGKEY_WIDTH, REGVAL_WIDTH, REGVAL_HEIGHT );

	m_WndReg[14].Create( _T("EFlags"), _T("00000000"), REGSTYLE, this, REGKEY_WIDTH, REGVAL_WIDTH, REGVAL_HEIGHT );
	m_WndReg[15].Create( _T("EIP"), _T("00000000"), REGSTYLE, this, REGKEY_WIDTH, REGVAL_WIDTH, REGVAL_HEIGHT );

	m_WndReg[16].Create( _T("Dr0"), _T("00000000"), REGSTYLE, this, REGKEY_WIDTH, REGVAL_WIDTH, REGVAL_HEIGHT );
	m_WndReg[17].Create( _T("Dr1"), _T("00000000"), REGSTYLE, this, REGKEY_WIDTH, REGVAL_WIDTH, REGVAL_HEIGHT );
	m_WndReg[18].Create( _T("Dr2"), _T("00000000"), REGSTYLE, this, REGKEY_WIDTH, REGVAL_WIDTH, REGVAL_HEIGHT );
	m_WndReg[19].Create( _T("Dr3"), _T("00000000"), REGSTYLE, this, REGKEY_WIDTH, REGVAL_WIDTH, REGVAL_HEIGHT );
	m_WndReg[20].Create( _T("Dr6"), _T("00000000"), REGSTYLE, this, REGKEY_WIDTH, REGVAL_WIDTH, REGVAL_HEIGHT );
	m_WndReg[21].Create( _T("Dr7"), _T("00000000"), REGSTYLE, this, REGKEY_WIDTH, REGVAL_WIDTH, REGVAL_HEIGHT );

	SetCurrThread( NULL );

	return TRUE;
}

void CDebugRegisterView::OnSize(UINT nType, int cx, int cy)
{
	int	y=8-REGVAL_HEIGHT;

	if ( m_WndReg[0].m_hWnd ) m_WndReg[0].MoveWindow( 8, y+=REGVAL_HEIGHT, REGVAL_WIDTH, REGVAL_HEIGHT );
	if ( m_WndReg[1].m_hWnd ) m_WndReg[1].MoveWindow( 8, y+=REGVAL_HEIGHT, REGVAL_WIDTH, REGVAL_HEIGHT );
	if ( m_WndReg[2].m_hWnd ) m_WndReg[2].MoveWindow( 8, y+=REGVAL_HEIGHT, REGVAL_WIDTH, REGVAL_HEIGHT );
	if ( m_WndReg[3].m_hWnd ) m_WndReg[3].MoveWindow( 8, y+=REGVAL_HEIGHT, REGVAL_WIDTH, REGVAL_HEIGHT );
	if ( m_WndReg[4].m_hWnd ) m_WndReg[4].MoveWindow( 8, y+=REGVAL_HEIGHT, REGVAL_WIDTH, REGVAL_HEIGHT );
	if ( m_WndReg[5].m_hWnd ) m_WndReg[5].MoveWindow( 8, y+=REGVAL_HEIGHT, REGVAL_WIDTH, REGVAL_HEIGHT );
	y+=REGVAL_HEIGHT;
	if ( m_WndReg[6].m_hWnd ) m_WndReg[6].MoveWindow( 8, y+=REGVAL_HEIGHT, REGVAL_WIDTH, REGVAL_HEIGHT );
	if ( m_WndReg[7].m_hWnd ) m_WndReg[7].MoveWindow( 8, y+=REGVAL_HEIGHT, REGVAL_WIDTH, REGVAL_HEIGHT );
	y+=REGVAL_HEIGHT;
	if ( m_WndReg[8].m_hWnd ) m_WndReg[8].MoveWindow( 8, y+=REGVAL_HEIGHT, REGVAL_WIDTH, REGVAL_HEIGHT );
	if ( m_WndReg[9].m_hWnd ) m_WndReg[9].MoveWindow( 8, y+=REGVAL_HEIGHT, REGVAL_WIDTH, REGVAL_HEIGHT );
	if ( m_WndReg[10].m_hWnd ) m_WndReg[10].MoveWindow( 8, y+=REGVAL_HEIGHT, REGVAL_WIDTH, REGVAL_HEIGHT );
	if ( m_WndReg[11].m_hWnd ) m_WndReg[11].MoveWindow( 8, y+=REGVAL_HEIGHT, REGVAL_WIDTH, REGVAL_HEIGHT );
	if ( m_WndReg[12].m_hWnd ) m_WndReg[12].MoveWindow( 8, y+=REGVAL_HEIGHT, REGVAL_WIDTH, REGVAL_HEIGHT );
	if ( m_WndReg[13].m_hWnd ) m_WndReg[13].MoveWindow( 8, y+=REGVAL_HEIGHT, REGVAL_WIDTH, REGVAL_HEIGHT );
	y+=REGVAL_HEIGHT;
	if ( m_WndReg[14].m_hWnd ) m_WndReg[14].MoveWindow( 8, y+=REGVAL_HEIGHT, REGVAL_WIDTH, REGVAL_HEIGHT );
	if ( m_WndReg[15].m_hWnd ) m_WndReg[15].MoveWindow( 8, y+=REGVAL_HEIGHT, REGVAL_WIDTH, REGVAL_HEIGHT );
	y+=REGVAL_HEIGHT;
	if ( m_WndReg[16].m_hWnd ) m_WndReg[16].MoveWindow( 8, y+=REGVAL_HEIGHT, REGVAL_WIDTH, REGVAL_HEIGHT );
	if ( m_WndReg[17].m_hWnd ) m_WndReg[17].MoveWindow( 8, y+=REGVAL_HEIGHT, REGVAL_WIDTH, REGVAL_HEIGHT );
	if ( m_WndReg[18].m_hWnd ) m_WndReg[18].MoveWindow( 8, y+=REGVAL_HEIGHT, REGVAL_WIDTH, REGVAL_HEIGHT );
	if ( m_WndReg[19].m_hWnd ) m_WndReg[19].MoveWindow( 8, y+=REGVAL_HEIGHT, REGVAL_WIDTH, REGVAL_HEIGHT );
	if ( m_WndReg[20].m_hWnd ) m_WndReg[20].MoveWindow( 8, y+=REGVAL_HEIGHT, REGVAL_WIDTH, REGVAL_HEIGHT );
	if ( m_WndReg[21].m_hWnd ) m_WndReg[21].MoveWindow( 8, y+=REGVAL_HEIGHT, REGVAL_WIDTH, REGVAL_HEIGHT );
}

void CDebugRegisterView::OnReset()
{
	LoadState( _T("DEBUGREGISTERVIEW_PERM") );
	SetCurrThread( hThread );
}

void CDebugRegisterView::OnDebugFinished()
{
	RememberVisibility( IsWindowVisible() );
	SaveState( _T("DEBUGREGISTERVIEW_PERM") );
}

void CDebugRegisterView::SetCurrThread(HANDLE h)
{
	hThread = h;
	// if hthread == NULL then process is running and register contents are invalid

	if ( hThread == NULL ) { for ( int i = 0; i<22; i++ ) m_WndReg[i].SetInvalid(); return; }

	c.ContextFlags =	CONTEXT_CONTROL |
						CONTEXT_INTEGER |
						CONTEXT_SEGMENTS |
						CONTEXT_FLOATING_POINT |
						CONTEXT_DEBUG_REGISTERS |
						CONTEXT_EXTENDED_REGISTERS ;

	BOOL trc = GetThreadContext( hThread, &c );

	m_WndReg[0].SetValueNumeric(  c.Eax, 16, "0x0" );
	m_WndReg[1].SetValueNumeric(  c.Ebx, 16, "0x0" );
	m_WndReg[2].SetValueNumeric(  c.Ecx, 16, "0x0" );
	m_WndReg[3].SetValueNumeric(  c.Edx, 16, "0x0" );
	m_WndReg[4].SetValueNumeric(  c.Esi, 16, "0x0" );
	m_WndReg[5].SetValueNumeric(  c.Edi, 16, "0x0" );
	m_WndReg[6].SetValueNumeric(  c.Ebp, 16, "0x0" );
	m_WndReg[7].SetValueNumeric(  c.Esp, 16, "0x0" );

	m_WndReg[8].SetValueNumeric(  c.SegCs, 16, "0x0" );
	m_WndReg[9].SetValueNumeric(  c.SegDs, 16, "0x0" );
	m_WndReg[10].SetValueNumeric( c.SegEs, 16, "0x0" );
	m_WndReg[11].SetValueNumeric( c.SegFs, 16, "0x0" );
	m_WndReg[12].SetValueNumeric( c.SegGs, 16, "0x0" );
	m_WndReg[13].SetValueNumeric( c.SegSs, 16, "0x0" );
	
	m_WndReg[14].SetValueNumeric( c.EFlags, 16, "0x0" );
	m_WndReg[15].SetValueNumeric( c.Eip, 16, "0x0" );

	m_WndReg[16].SetValueNumeric( c.Dr0, 16, "0x0" );
	m_WndReg[17].SetValueNumeric( c.Dr1, 16, "0x0" );
	m_WndReg[18].SetValueNumeric( c.Dr2, 16, "0x0" );
	m_WndReg[19].SetValueNumeric( c.Dr3, 16, "0x0" );
	m_WndReg[20].SetValueNumeric( c.Dr6, 16, "0x0" );
	m_WndReg[21].SetValueNumeric( c.Dr7, 16, "0x0" );
}



void CDebugRegisterView::SetThreadRegisters( )
{
	if (hThread == NULL) return;

	c.Eax = m_WndReg[0].GetValue();
	c.Ebx = m_WndReg[1].GetValue();
	c.Ecx = m_WndReg[2].GetValue();
	c.Edx = m_WndReg[3].GetValue();
	c.Esi = m_WndReg[4].GetValue();
	c.Edi = m_WndReg[5].GetValue();
	c.Ebp = m_WndReg[6].GetValue();
	c.Esp = m_WndReg[7].GetValue();
	c.SegCs = m_WndReg[8].GetValue();
	c.SegDs = m_WndReg[9].GetValue();
	c.SegEs = m_WndReg[10].GetValue();
	c.SegFs = m_WndReg[11].GetValue();
	c.SegGs = m_WndReg[12].GetValue();
	c.SegSs = m_WndReg[13].GetValue();
	c.EFlags = m_WndReg[14].GetValue();
	c.Eip = m_WndReg[15].GetValue();
	c.Dr0 = m_WndReg[16].GetValue();
	c.Dr1 = m_WndReg[17].GetValue();
	c.Dr2 = m_WndReg[18].GetValue();
	c.Dr3 = m_WndReg[19].GetValue();
	c.Dr6 = m_WndReg[20].GetValue();
	c.Dr7 = m_WndReg[21].GetValue();

	SetThreadContext( hThread, &c );
}
