// KeyValueCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "forge.h"
#include "KeyValueCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CKeyValueCtrl

CKeyValueCtrl::CKeyValueCtrl()
{
}

CKeyValueCtrl::~CKeyValueCtrl()
{
}


BEGIN_MESSAGE_MAP(CKeyValueCtrl, CWnd)
	//{{AFX_MSG_MAP(CKeyValueCtrl)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CKeyValueCtrl message handlers

BOOL CKeyValueCtrl::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	return Create( lpszWindowName, _T(""), dwStyle, pParentWnd, (rect.right-rect.left)/3, rect.right-rect.left, rect.bottom-rect.top );
}

BOOL CKeyValueCtrl::Create(LPCTSTR szKey, LPCTSTR szValue, DWORD dwStyle, CWnd *pParent, int nKeyWidth, int nWidth, int nHeight)
{
	m_Font.CreatePointFont( 100, "Courier", NULL );
	if ( !CWnd::Create(NULL, szKey, dwStyle, CRect(0,0,nWidth,nHeight), pParent, 0x0FFFF, NULL ) ) return FALSE;
	if (!m_Static.Create( szKey, WS_CHILD | WS_VISIBLE, CRect(0,0,nKeyWidth, nHeight), this ) ) return FALSE;
	if (!m_Edit.Create( WS_CHILD|WS_VISIBLE|SS_LEFT, CRect(nKeyWidth,0,nWidth,nHeight),this,0x0FFFF) ) return FALSE;
	m_Edit.SetWindowText( szValue );

	m_Static.SetFont( &m_Font );
	m_Edit.SetFont( &m_Font );

	KeyWidth = nKeyWidth;
	
	if ( szValue ) SetValid(); else SetInvalid();

	return TRUE;
}

void CKeyValueCtrl::OnSize(UINT nType, int cx, int cy) 
{
	if ( m_Static.m_hWnd ) m_Static.MoveWindow( 0, 0, KeyWidth, cy );
	if ( m_Edit.m_hWnd )   m_Edit.MoveWindow( KeyWidth, 0, cx-KeyWidth, cy );
}

void CKeyValueCtrl::SetValueNumeric( int n, int radix, LPCTSTR bc )
{
	SetValid();

	int	p = 0;

	CString	text;

	unsigned int nn = (unsigned int)n;

	while( nn )
	{
		unsigned int dig = nn % radix;
		nn=nn/radix;
		switch( dig )
		{
		case 0:		text = _T("0") + text; break ;
		case 1:		text = _T("1") + text; break ;
		case 2:		text = _T("2") + text; break ;
		case 3:		text = _T("3") + text; break ;
		case 4:		text = _T("4") + text; break ;
		case 5:		text = _T("5") + text; break ;
		case 6:		text = _T("6") + text; break ;
		case 7:		text = _T("7") + text; break ;
		case 8:		text = _T("8") + text; break ;
		case 9:		text = _T("9") + text; break ;
		case 10:	text = _T("A") + text; break ;
		case 11:	text = _T("B") + text; break ;
		case 12:	text = _T("C") + text; break ;
		case 13:	text = _T("D") + text; break ;
		case 14:	text = _T("E") + text; break ;
		case 15:	text = _T("F") + text; break ;
		default:	text = _T("?") + text; break ;
		}
		p++;
	}

	if ( radix == 16 ) while (p<8) { text=_T("0")+text; p++; }

	if ( bc ) text = bc+text;

	m_Edit.SetWindowText( text );
}

void CKeyValueCtrl::SetInvalid()
{
	m_bValid = FALSE;
}

void CKeyValueCtrl::SetValid()
{
	m_bValid = TRUE;
}

int CKeyValueCtrl::GetValue()
{

	CString	c;

	m_Edit.GetWindowText( c );

	int		acc = 0;
	int		radix = 10;
	int		sign = 1;
	TCHAR	ch;

	c.TrimLeft();
	if ( c.GetLength() == 0 ) return 0;
	if ( c[0] == '-' ) sign = -1;
	c.TrimLeft('-');

	c.TrimLeft('0');
	if ( c.GetLength() == 0 ) return 0;
	if ( c[0] == 'x' || c[0] == 'X' || c[0] == '$' ) radix = 16;
	c.TrimLeft(_T("xX$") );

	while (c.GetLength())
	{
		acc*=radix;
		ch = c[0];
		c = c.Right( c.GetLength() - 1 );
		switch( ch )
		{
		case '0':	acc+=0; break;
		case '1':	acc+=1; break;
		case '2':	acc+=2; break;
		case '3':	acc+=3; break;
		case '4':	acc+=4; break;
		case '5':	acc+=5; break;
		case '6':	acc+=6; break;
		case '7':	acc+=7; break;
		case '8':	acc+=8; break;
		case '9':	acc+=9; break;
		case 'a':	acc+=10; break;
		case 'b':	acc+=11; break;
		case 'c':	acc+=12; break;
		case 'd':	acc+=13; break;
		case 'e':	acc+=14; break;
		case 'f':	acc+=15; break;
		case 'A':	acc+=10; break;
		case 'B':	acc+=11; break;
		case 'C':	acc+=12; break;
		case 'D':	acc+=13; break;
		case 'E':	acc+=14; break;
		case 'F':	acc+=15; break;
		default:
			return 0;
		}
	}

	
	return acc;
}
