// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__CC3FF848_2AE8_11D3_A84C_00C0F0219F72__INCLUDED_)
#define AFX_MAINFRM_H__CC3FF848_2AE8_11D3_A84C_00C0F0219F72__INCLUDED_

#include "BuildWindow.h"	// Added by ClassView
#include "ProjectWindow.H"
#include "baseconvertor.h"
#include "asciichart.h"
#include "helpwindow.h"
#include "Project.h"	// Added by ClassView
#include "ConfigIDE.h"	// Added by ClassView

#include "DebugCodeView.h"
#include "DebugMemoryView.h"
#include "DebugRegisterView.h"
#include "DebugDStackView.h"
#include "DebugRStackView.h"
#include "DebugConsole.h"

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CMainFrame : public CMDIFrameWnd
{
	DECLARE_DYNAMIC(CMainFrame)
public:
	CMainFrame();

// Attributes
public:

// Operations
public:
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL DestroyWindow();
	virtual BOOL OnChildNotify(UINT message, WPARAM wParam, LPARAM lParam, LRESULT* pLResult);
	virtual void ActivateFrame(int nCmdShow = -1);
	//}}AFX_VIRTUAL

// Implementation
public:
	CBaseConvertor * m_dlgBaseConvertor;
	CASCIIChart * m_dlgASCIIChart;
	CString m_csTempBuildDir;
	CString m_csProjectDir;
	BOOL m_defaultdebug;
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

public:
	void RaiseBuildWindow( void );
	void RaiseProjectWindow( void );
	BOOL bAutoRaise_Build;
	BOOL bAutoRaise_Project;
	void ToggleWindowVisibility( CWnd *c );
	void CloseAllDocuments( void );
	BOOL ConfirmCloseWorkspace( void );
	CProject *m_Project;
	CHelpWindow * m_wndHelp;
// protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;
	CToolBar    m_wndToolsBar;
	CToolBar	m_wndCompilerToolBar;
	CToolBar	m_wndViewWinBar;
	CToolBar	m_wndDebugBar;
	CBuildWindow m_wndBuildBar;
	CProjectWindow m_wndProjectBar;

	CDebugCodeView		m_wndCodeView;
	CDebugMemoryView	m_wndMemView;
	CDebugRegisterView	m_wndRegView;
	CDebugDStackView	m_wndDStackView;
	CDebugRStackView	m_wndRStackView;
	CDebugConsole		m_wndDebugConsole;

// Generated message map functions
protected:
public:
	void UpdateUserTool( CCmdUI *pCmdUI, CString& cs );
	void InvokeUserTool( LPCTSTR szCommand );
	CString m_csUserTool1;
	CString m_csUserTool2;
	CString m_csUserTool3;
	CString m_csUserTool4;
	CString m_csUserTool5;
	CString m_csUserTool6;
	CString m_csUserTool7;
	CString m_csUserTool8;
	CFindReplaceDialog * m_ActiveFindDialog;
	CString m_csConsoleStartDir;
	void DoOpenworkspace( LPCTSTR szFileName );
	void DoConfigSheet( int start );
	BOOL VisWin( CWnd *wnd );
	void DebugMemDump( LPVOID target_address, int width );
	void ReadTargetMemory( LPVOID buff, int len, LPVOID TargetAddress );
	LPVOID GetTargetBaseAddress( void );
	void CloseDebugWindows( void );
	void OpenDebugWindows( void );
	void DebugOutputText( CString& cs );
	void SwitchDebugLevel( int new_level );
	BOOL CheckDebuggerTermination( void );
	int m_DebugLevel;
	CDialogBar m_wndActiveTarget;
protected:
	afx_msg void OnInitMenu(CMenu* pMenu);
	void SpawnHTML( LPCTSTR url );
	void ModifyToolbar( CToolBar *tb );
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnUpdateToolsBasecon(CCmdUI* pCmdUI);
	afx_msg void OnToolsBasecon();
	afx_msg void OnUpdateToolsAscii(CCmdUI* pCmdUI);
	afx_msg void OnToolsAscii();
	afx_msg void OnHelpAns();
	afx_msg void OnUpdateHelpAns(CCmdUI* pCmdUI);
	afx_msg void OnUpdateHelpLookup(CCmdUI* pCmdUI);
	afx_msg void OnHelpLookup();
	afx_msg void OnUpdateFileCloseworkspace(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileNewworkspace(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileOpenworkspace(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileSaveworkspace(CCmdUI* pCmdUI);
	afx_msg void OnFileNewworkspace();
	afx_msg void OnFileOpenworkspace();
	afx_msg void OnFileCloseworkspace();
	afx_msg void OnFileSaveworkspace();
	afx_msg void OnUpdateProjectAddfiles(CCmdUI* pCmdUI);
	afx_msg void OnUpdateProjectSettings(CCmdUI* pCmdUI);
	afx_msg void OnProjectAddfiles();
	afx_msg void OnProjectSettings();
	afx_msg void OnViewCompilertoolbar();
	afx_msg void OnUpdateViewCompilertoolbar(CCmdUI* pCmdUI);
	afx_msg void OnViewToolstoolbar();
	afx_msg void OnUpdateViewToolstoolbar(CCmdUI* pCmdUI);
	afx_msg void OnViewCapture();
	afx_msg void OnUpdateViewCapture(CCmdUI* pCmdUI);
	afx_msg void OnViewProjectwin();
	afx_msg void OnUpdateViewProjectwin(CCmdUI* pCmdUI);
	afx_msg void OnViewView();
	afx_msg void OnUpdateViewView(CCmdUI* pCmdUI);
	afx_msg void OnToolsConfigide();
	afx_msg void OnUpdateToolsConfigide(CCmdUI* pCmdUI);
	afx_msg void OnClose();
	afx_msg void OnUpdateProjectNewtarget(CCmdUI* pCmdUI);
	afx_msg void OnProjectNewtarget();
	afx_msg void OnUpdateHelpVfxman(CCmdUI* pCmdUI);
	afx_msg void OnHelpVfxman();
	afx_msg void OnCompile();
	afx_msg void OnUpdateCompile(CCmdUI* pCmdUI);
	afx_msg void OnExecute();
	afx_msg void OnUpdateExecute(CCmdUI* pCmdUI);
	afx_msg void OnUpdatePureconsole(CCmdUI* pCmdUI);
	afx_msg void OnPureconsole();
	afx_msg void OnDebugrun();
	afx_msg void OnUpdateDebugrun(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDebugCode(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDebugDstack(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDebugGo(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDebugMem(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDebugReg(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDebugRstack(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDebugSuspend(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDebugTerminate(CCmdUI* pCmdUI);
	afx_msg void OnDebugCode();
	afx_msg void OnDebugDstack();
	afx_msg void OnDebugMem();
	afx_msg void OnDebugReg();
	afx_msg void OnDebugRstack();
	afx_msg void OnDebugGo();
	afx_msg void OnDebugSuspend();
	afx_msg void OnDebugTerminate();
	afx_msg void OnDebuggerStep();
	afx_msg void OnUpdateDebuggerStep(CCmdUI* pCmdUI);
	afx_msg void OnCompilerConfig();
	afx_msg void OnUpdateCompilerConfig(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMrw1(CCmdUI* pCmdUI);
	afx_msg void OnUsertool1();
	afx_msg void OnUpdateUsertool1(CCmdUI* pCmdUI);
	afx_msg void OnUsertool2();
	afx_msg void OnUpdateUsertool2(CCmdUI* pCmdUI);
	afx_msg void OnUsertool3();
	afx_msg void OnUpdateUsertool3(CCmdUI* pCmdUI);
	afx_msg void OnUsertool4();
	afx_msg void OnUpdateUsertool4(CCmdUI* pCmdUI);
	afx_msg void OnUsertool5();
	afx_msg void OnUpdateUsertool5(CCmdUI* pCmdUI);
	afx_msg void OnUsertool6();
	afx_msg void OnUpdateUsertool6(CCmdUI* pCmdUI);
	afx_msg void OnUsertool7();
	afx_msg void OnUpdateUsertool7(CCmdUI* pCmdUI);
	afx_msg void OnUsertool8();
	afx_msg void OnUpdateUsertool8(CCmdUI* pCmdUI);
	//}}AFX_MSG
	afx_msg void OnMrwCommand( UINT nID );
	DECLARE_MESSAGE_MAP()
private:
	BOOL m_bFirst;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__CC3FF848_2AE8_11D3_A84C_00C0F0219F72__INCLUDED_)
