// Project.h: interface for the CProject class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PROJECT_H__3FFBCDA0_2D40_11D3_A84C_00C0F0219F72__INCLUDED_)
#define AFX_PROJECT_H__3FFBCDA0_2D40_11D3_A84C_00C0F0219F72__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "projectreadstatus.h"

class CSource
{
public:
	CSource	*next;
	CString	m_szPath;
};

#define	MAX_SOURCES_PER_TARGET 128

class CTarget
{
public:
	void DemoteTargetSource( int index );
	void PromoteTargetSource( int index );
	void RemoveSourceFromTarget( int index );
	int m_Platform;			// 0 = gui, 1 = console, 2 = dll
	BOOL m_bOptimised;
	int GetNextFreeSourceSlot( void );
	BOOL m_bBuildType;			// true for debug mode
	CTarget *next;
	CString m_szName;		// internal name of build target (also EXE name)
	CSource *Sources[MAX_SOURCES_PER_TARGET];
	CString m_szPath;		// if NULL string then use project build path
	CTarget();
	virtual ~CTarget();
};

class CProject  
{
public:
	CProjectReadStatus * m_prsDialog;
	void SetTargetOptState( LPCTSTR arg );
	void SetTargetPlatform( LPCTSTR arg );
	void AddSourceToTarget( CTarget *targ, LPCTSTR source );
	CTarget * FindTargetByName( CString& name );
	CSource * FindSourceByName( LPCTSTR name );
	void EditTargetProperties( LPCTSTR name );
	void SetTargetCodeGen( LPCTSTR type );
	void AddSourceToLastTarget( LPCSTR sourcename );
	void SetLastTargetPath( LPCTSTR path );
	BOOL AddTarget( LPCTSTR name, BOOL bFromFile = FALSE );
	BOOL IsSourceInUse( CString& name );
	void RemoveSourceByName( CString& name );
	BOOL DoesTargetExist( LPCTSTR path );
	BOOL DoesSourceExist( LPCTSTR path );
	BOOL ProcessCommand( CString& command, CString& arg );
	CString m_ProjectFile;
	void Save( void );
	void Load( LPCTSTR szFileName );
	BOOL GenerateMakeFile( LPCTSTR targetname  );
	void SetBuildPath( LPCTSTR text );
	CString m_szBuildPath;
	CSource * GetLastSourceEntry( void );
	CTarget * GetLastTargetEntry( void );
	BOOL AddSource( LPCTSTR cs );
	CSource	*SourceList;
	CTarget *TargetList;
	CProject();
	virtual ~CProject();

};

#endif // !defined(AFX_PROJECT_H__3FFBCDA0_2D40_11D3_A84C_00C0F0219F72__INCLUDED_)
