// ProjectWindow.h: interface for the CBuildWindow class.
//
//////////////////////////////////////////////////////////////////////

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "Sizecbar.h"

class CProjectWindow : public CSizingControlBar  
{
	DECLARE_DYNAMIC(CProjectWindow)
public:
	void GetSelectedTargetName( CString& c );
	void UpdateTargetBranch( void );
	void UpdateSourceBranch( void );
	HTREEITEM ht_Targets;
	HTREEITEM ht_Sources;
	CTreeCtrl m_Tree;
	void ResetProjectWindow( BOOL bProjectOpen );

	virtual BOOL Create( LPCTSTR lpszWindowName, CWnd* pParentWnd, CSize sizeDefault, BOOL bHasGripper);
	CProjectWindow();
	virtual ~CProjectWindow();

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CProjectWindow)
	protected:
	virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult);
	//}}AFX_VIRTUAL

protected:
	//{{AFX_MSG(CProjectWindow)
	afx_msg void OnSize( UINT nType, int cx, int cy );
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnProjectSourceOpenselected();
	afx_msg void OnUpdateProjectSourceOpenselected(CCmdUI* pCmdUI);
	afx_msg void OnUpdateProjectSourceRemoveselected(CCmdUI* pCmdUI);
	afx_msg void OnProjectSourceRemoveselected();
	afx_msg void OnTargetProperties();
	afx_msg void OnTargetDelete();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

