
// ToEndOfSelection has no effect

// scrapped syntax highlighting
//
// save file appears pissed (could be the GetWindowText() call )

// SourceView.cpp : implementation of the CSourceView class
//

#include <afxdlgs.h>
#include "stdafx.h"
#include "forge.h"
#include "SourceDoc.h"
#include "SourceView.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSourceView

IMPLEMENT_DYNCREATE(CSourceView, CView)

static UINT WM_FINDREPLACE = ::RegisterWindowMessage(FINDMSGSTRING);

BEGIN_MESSAGE_MAP(CSourceView, CView)
	//{{AFX_MSG_MAP(CSourceView)
	ON_WM_SIZE()
	ON_WM_PAINT()
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY, OnUpdateEditCopy)
	ON_COMMAND(ID_EDIT_CUT, OnEditCut)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CUT, OnUpdateEditCut)
	ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE, OnUpdateEditPaste)
	ON_COMMAND(ID_EDIT_UNDO, OnEditUndo)
	ON_UPDATE_COMMAND_UI(ID_EDIT_UNDO, OnUpdateEditUndo)
	ON_COMMAND(ID_EDIT_COMMENT, OnEditComment)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COMMENT, OnUpdateEditComment)
	ON_WM_SETFOCUS()
	ON_COMMAND(ID_EDIT_SELECT_ALL, OnEditSelectAll)
	ON_UPDATE_COMMAND_UI(ID_EDIT_SELECT_ALL, OnUpdateEditSelectAll)
	ON_COMMAND(ID_EDIT_GOTOLINE, OnEditGotoline)
	ON_UPDATE_COMMAND_UI(ID_EDIT_GOTOLINE, OnUpdateEditGotoline)
	ON_COMMAND(ID_VIEW_FULLSCREEN, OnViewFullscreen)
	ON_UPDATE_COMMAND_UI(ID_VIEW_FULLSCREEN, OnUpdateViewFullscreen)
	ON_COMMAND(ID_EDIT_REPEAT, OnEditRepeat)
	ON_UPDATE_COMMAND_UI(ID_EDIT_REPEAT, OnUpdateEditRepeat)
	ON_COMMAND(ID_EDIT_REPLACE, OnEditReplace)
	ON_UPDATE_COMMAND_UI(ID_EDIT_REPLACE, OnUpdateEditReplace)
	ON_WM_TIMER()
	ON_COMMAND(ID_EDIT_FIND, OnEditFind)
	ON_UPDATE_COMMAND_UI(ID_EDIT_FIND, OnUpdateEditFind)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
	ON_REGISTERED_MESSAGE( WM_FINDREPLACE, OnFindReplace )
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSourceView construction/destruction

CSourceView::CSourceView()
{
	m_nMarginWidth = 16;
	m_crMarginColor = RGB( 224, 224, 224 );
	m_Font.CreatePointFont( 100, "Courier" );
	bFullScreen = FALSE;
}

CSourceView::~CSourceView()
{
	m_Font.DeleteObject();
}

BOOL CSourceView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CSourceView drawing

void CSourceView::OnDraw(CDC* pDC)
{
	CSourceDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CSourceView printing

BOOL CSourceView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CSourceView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CSourceView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CSourceView diagnostics

#ifdef _DEBUG
void CSourceView::AssertValid() const
{
	CView::AssertValid();
}

void CSourceView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CSourceDoc* CSourceView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSourceDoc)));
	return (CSourceDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSoureView Utilities

void CSourceView::ActionForLines( int start, int end)
{

	ASSERT(m_RichEdit.LockWindowUpdate());

	CHARRANGE cr;
	m_RichEdit.GetSel(cr);

	if (start == -1)
	{
		start = m_RichEdit.LineFromChar( cr.cpMin );
		end   = m_RichEdit.LineFromChar( cr.cpMax ) - 1;
		if (end<start) end = start;
	}

	// Handle the "visible range" condition
	if ( start == -2 )
	{
		POINTL	pl;
		RECT	rect;
		m_RichEdit.GetClientRect( &rect );
		pl.x = rect.right;
		pl.y = rect.bottom;
		start = m_RichEdit.GetFirstVisibleLine();
		end   = m_RichEdit.LineFromChar( m_RichEdit.SendMessage( EM_CHARFROMPOS, 0, (LPARAM)&pl ) );
	}
	
	if (end==-1) end=start;	// enforce single line

	long orig = m_RichEdit.SetEventMask( ENM_NONE );

	CString textline;
	for ( int i=start;i<=end;i++)
	{
		int		 ll =	m_RichEdit.LineLength( m_RichEdit.LineIndex( i ) );
		LPTSTR buff	=	textline.GetBuffer( ll+4 );
		m_RichEdit.GetLine( i, buff, ll );
		textline.ReleaseBuffer( ll );
		(this->*m_ActionXT)(i,textline);
		m_RichEdit.SetSel( m_RichEdit.LineIndex( i ), m_RichEdit.LineIndex( i ) + ll );
		m_RichEdit.ReplaceSel( textline, TRUE );
	}

	m_RichEdit.SetEventMask( orig );
	WriteBack();

	m_RichEdit.SetSel(cr);
	m_RichEdit.UnlockWindowUpdate();
}


void CSourceView::WriteBack()
{

	// HACK: Change use of GetWindowText to solve the >64k problem with rich-edits
	// m_RichEdit.GetWindowText( GetDocument()->m_csText );

	TEXTRANGE	tr;

	int	doclen = m_RichEdit.GetWindowTextLength();					// get text length
	LPTSTR buff = GetDocument()->m_csText.GetBuffer( doclen+1 );	// loc document text buffer to correct size

	tr.chrg.cpMin = 0;
	tr.chrg.cpMax = doclen;
	tr.lpstrText = buff;

	int rc = ::SendMessage( m_RichEdit.m_hWnd, EM_GETTEXTRANGE, 0, (LPARAM)&tr );		// read text 

	GetDocument()->m_csText.ReleaseBuffer( doclen );				// release at zero terminate

	GetDocument()->SetModifiedFlag( TRUE );
	GetDocument()->UpdateAllViews( this );

	CSourceDoc *cd = (CSourceDoc *)GetDocument();
	int l = cd->m_DisplayTitle.GetLength();
	if ( cd->m_DisplayTitle.GetAt( l-1 ) != '*' )
		cd->m_DisplayTitle+=_T(" *");
	cd->SetTitle( cd->m_DisplayTitle );
}

/////////////////////////////////////////////////////////////////////////////
// CSoureView UI Updates

void CSourceView::OnUpdateEditCopy(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( TRUE );
}

void CSourceView::OnUpdateEditCut(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( TRUE );
}

void CSourceView::OnUpdateEditPaste(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( m_RichEdit.SendMessage( EM_CANPASTE, 0, 0) );
}


void CSourceView::OnUpdateEditUndo(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( m_RichEdit.SendMessage( EM_CANUNDO, 0, 0) );
}

void CSourceView::OnUpdateEditComment(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( TRUE );
}

void CSourceView::OnUpdateEditSelectAll(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( TRUE );
}

void CSourceView::OnUpdateEditGotoline(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( TRUE );
}

/////////////////////////////////////////////////////////////////////////////
// CSourceView message handlers

//
// Create( .. )
// 1) Create the CWnd as normal
// 2) Remove it's background brush with SetClassLong()
// 3) Create my richedit control
// 4) Set Richedit Font to something sensible
// 5) Set Richedit to NOTIFY parent of any mouse event or possible text change
//
BOOL CSourceView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	if (!CWnd::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext)) return FALSE;
	::SetClassLong( m_hWnd, GCL_HBRBACKGROUND, NULL );
	if (!m_RichEdit.Create( WS_CHILD | WS_VISIBLE | WS_HSCROLL | 
							ES_MULTILINE | ES_WANTRETURN | 
							ES_AUTOHSCROLL | ES_AUTOVSCROLL |
							ES_NOHIDESEL | WS_VSCROLL, CRect(0,0,0,0), this, 0 )) return FALSE;
	m_RichEdit.SetFont( &m_Font );
	m_RichEdit.SetEventMask( ENM_CHANGE | ENM_MOUSEEVENTS | ENM_SELCHANGE );
	m_RichEdit.SendMessage( EM_EXLIMITTEXT, 0, 4*1024*1024 );
	return TRUE;
}

//
// OnSize( ... )
// When the frame changes size, move the Richedit control to take up the left hand side of the window, minus
// the margin
//
void CSourceView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	if (m_RichEdit.m_hWnd)
		m_RichEdit.MoveWindow( m_nMarginWidth, 0, cx-m_nMarginWidth, cy );
}

//
// OnPaint( ... )
// Paint the Margin
//
void CSourceView::OnPaint() 
{
	CPaintDC dc(this);					// device context for painting

	CBrush br( m_crMarginColor );
	CPen   pn( PS_SOLID, 1, m_crMarginColor );

	CBrush *obr = dc.SelectObject( &br );
	CPen   *opn = dc.SelectObject( &pn );

	RECT	rect;
	GetClientRect( &rect );
	rect.left = rect.top = 0;
	rect.right = m_nMarginWidth;
	dc.Rectangle( &rect );

	dc.SelectObject( obr );
	dc.SelectObject( opn );
}

//
// OnCommand( .. )
// 1) Check the incoming command for notification that the richedit contents have changed.
// 2) If a text change occured copy the text backinto the document and set the modified flag. UpdateAll Views
// 3) Perform defaults
//
BOOL CSourceView::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	if ( ((HWND)lParam == m_RichEdit.m_hWnd) && (HIWORD(wParam)==EN_CHANGE) )
	{
		WriteBack();
	}

	return CView::OnCommand(wParam, lParam);
}

//
// OnUpdate( ... )
// 1) Disable the richedit event mask storing previous value. This will stop the nesting of TEXT CHANGE messages
//    when I change the view text
// 2) Remember the line offset of the view
// 3) Set the window text from the document store
// 4) restore the event mask
// 5) restore the visible line
//
void CSourceView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	long orig = m_RichEdit.SetEventMask( ENM_NONE );
	int vis   = m_RichEdit.GetFirstVisibleLine();
	m_RichEdit.SetWindowText( GetDocument()->m_csText );
	m_RichEdit.SetEventMask( orig );
	m_RichEdit.LineScroll(vis);
}


void CSourceView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();
}

void CSourceView::OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView) 
{
	CView::OnActivateView(bActivate, pActivateView, pDeactiveView);
}

//
// OnNotify( ... )
// Monitor reported mouse events from richedit looking for an RBUTTONUP event. When it occurs call the popup menu
//
BOOL CSourceView::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult) 
{

	MSGFILTER	*m = (MSGFILTER *)lParam;

	if ( (m->nmhdr.hwndFrom == m_RichEdit.m_hWnd ) &&
		 (m->nmhdr.code == EN_MSGFILTER ) &&
		 (m->msg == WM_RBUTTONUP ) )
	{
		POINT	p;
		p.x = LOWORD(m->lParam);
		p.y = HIWORD(m->lParam);
		m_RichEdit.ClientToScreen( &p );
		LaunchContextMenu( p.x, p.y );
	}


	if ( (m->nmhdr.hwndFrom == m_RichEdit.m_hWnd ) &&
		 (m->nmhdr.code == EN_SELCHANGE ) )
	{
		CMainFrame *cf = (CMainFrame *)AfxGetMainWnd();
		TCHAR	postext[128];
		sprintf( postext, "God Knows" );
		cf->m_wndStatusBar.SetPaneText( cf->m_wndStatusBar.CommandToIndex(ID_INDICATOR_POS), postext, TRUE );
	}


	return CView::OnNotify(wParam, lParam, pResult);
}

//
// LaunchContextMenu( ... )
// Will launch the EDIT menu from the Main frame as a popup menu.
//
void CSourceView::LaunchContextMenu(int x, int y)
{
	CWnd	*w = AfxGetMainWnd();
	CMenu	*cm = w->GetMenu();
	CMenu	*c;

	int i = 0;

	do 
	{
		c = cm->GetSubMenu( i++ );

		if (c)
		{
			CString fart;
			c->GetMenuString( 0, fart, MF_BYPOSITION );
	
			if ( fart.CompareNoCase( _T("&Undo\tCtrl+Z") ) == 0 ) 
			{
				cm = c;
				break;
			}
		}

	} while(i<1000);

	if ( cm != w->GetMenu() )
		cm->TrackPopupMenu( TPM_LEFTALIGN, x, y, w );

}

//
// OnSetFocus( ... )
// Pass on to richedit
//
void CSourceView::OnSetFocus(CWnd* pOldWnd) 
{
	CView::OnSetFocus(pOldWnd);
	m_RichEdit.SetFocus();	
}

void CSourceView::OnEditCopy() 
{
	m_RichEdit.SendMessage( WM_COPY, 0, 0 );
}

void CSourceView::OnEditCut() 
{
	m_RichEdit.SendMessage( WM_CUT, 0, 0 );
}

void CSourceView::OnEditPaste() 
{
	m_RichEdit.SendMessage( WM_PASTE, 0, 0 );
}

void CSourceView::OnEditUndo() 
{
	m_RichEdit.SendMessage( EM_UNDO, 0, 0 );
}

void CSourceView::OnEditComment() 
{
	m_ActionXT = ACTION_Comment;
	ActionForLines( -1, 0 );
	ToEndOfSelection();
}

void CSourceView::OnEditSelectAll() 
{
	m_RichEdit.SetSel(0,-1);
}

void CSourceView::OnEditGotoline() 
{
	CInputBox1	ip;
	int			l;
	l=ip.GetInput( _T("Information Request"), _T("Enter the line number you wish to jump to") );
	m_RichEdit.SetSel( m_RichEdit.LineIndex(l), m_RichEdit.LineIndex(l) );
}

/////////////////////////////////////////////////////////////////////////////
// CSourceView Actions for lines/selections

void CSourceView::ACTION_Comment(int iLine, CString& cs )
{
	CString	test = cs.Left( 10 );
	if ( test.CompareNoCase( _T("\\ FORGE:  ") ) == 0 )
	{
		// Uncomment cs
		cs = cs.Right( cs.GetLength() - 10 );
	} else {
		// Comment cs
		cs = _T("\\ FORGE:  ")+cs;
	}
}

/////////////////////////////////////////////////////////////////////////////

void CSourceView::GetSelectedWord(CString & cs)
{
	CHARRANGE	cr;
	m_RichEdit.GetSel( cr );

	int		 ll =	m_RichEdit.LineLength( cr.cpMin );		// length of line
	int		 l  =   m_RichEdit.LineFromChar( cr.cpMin );	// line index
	LPTSTR buff	=	cs.GetBuffer( ll+4 );
	m_RichEdit.GetLine( l, buff, ll );						// read whole line
	cs.ReleaseBuffer( ll );

	int ls = m_RichEdit.LineIndex( l );						// ls = char start of line
	int	start, end;

	start = cr.cpMin - ls;									// start and end character offsets for CString
	end   = cr.cpMax - ls;

	// Find start of word: count back START until we find a whitespace or start of line

	TCHAR	r;
	do
	{
		r = '\0';
		if (start>0) r = cs.GetAt(start--);
	} while ( (r!='\t') && (r!=' ') && (r!='\r') && (r!='\n') && (start!=0) );
	if (start!=0) start++;

	// Now count forward for END
	do
	{
		r = '\0';
		if (end<ll) r = cs.GetAt(end++);
	} while ( (r!='\t') && (r!=' ') && (r!='\r') && (r!='\n') && (end<ll ) );

	// return selected word
	if (end>start) cs=cs.Mid( start, end-start );
	else cs = "";
	cs.TrimLeft();
	cs.TrimRight();
}



void CSourceView::ToEndOfSelection()
{
	CHARRANGE	cr;
	m_RichEdit.GetSel(cr);
	cr.cpMin = cr.cpMax;
	m_RichEdit.SetSel(cr);
}

void CSourceView::OnViewFullscreen() 
{
}

void CSourceView::OnUpdateViewFullscreen(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( FALSE );
}

BOOL CSourceView::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo) 
{
	BOOL rc = CView::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);

	switch( nID )
	{
	case ID_FILE_SAVE:
	case ID_FILE_SAVE_AS:
		CSourceDoc *cd = (CSourceDoc *)GetDocument();
		cd->SetTitle( cd->m_DisplayTitle );
		break;
	}

	return rc;
}

void CSourceView::OnEditRepeat() 
{
}

void CSourceView::OnEditReplace() 
{
	CMainFrame *cf = (CMainFrame *)AfxGetMainWnd();
	if ( cf->m_ActiveFindDialog == NULL )
	{
		cf->m_ActiveFindDialog = new CFindReplaceDialog();
		cf->m_ActiveFindDialog->Create( FALSE, m_csFindText, m_csReplaceText, FR_DOWN, this );
	} else {
		::MessageBeep(0);
	}
}

void CSourceView::OnEditFind() 
{
	CMainFrame *cf = (CMainFrame *)AfxGetMainWnd();
	if ( cf->m_ActiveFindDialog == NULL )
	{
		cf->m_ActiveFindDialog = new CFindReplaceDialog();
		cf->m_ActiveFindDialog->Create( TRUE, m_csFindText, m_csReplaceText, FR_DOWN, this );
	} else {
		::MessageBeep(0);
	}
}

void CSourceView::OnUpdateEditFind(CCmdUI* pCmdUI) 
{
	CMainFrame *cf = (CMainFrame *)AfxGetMainWnd();
	pCmdUI->Enable( cf->m_ActiveFindDialog == NULL );
}

void CSourceView::OnUpdateEditReplace(CCmdUI* pCmdUI) 
{
	CMainFrame *cf = (CMainFrame *)AfxGetMainWnd();
	pCmdUI->Enable( cf->m_ActiveFindDialog == NULL );
}

void CSourceView::OnUpdateEditRepeat(CCmdUI* pCmdUI) 
{
//	pCmdUI->Enable( m_csFindText.GetLength()!=0 );
	pCmdUI->Enable( FALSE );
}

LONG CSourceView::OnFindReplace(WPARAM wParam, LPARAM lParam)
{
	CMainFrame *cf = (CMainFrame *)AfxGetMainWnd();
	CFindReplaceDialog *frd = cf->m_ActiveFindDialog->GetNotifier( lParam );

	if ( frd->ReplaceAll() )		::MessageBox( HWND_DESKTOP, "ReplaceAll",		"FINDACTION", MB_OK );

	if ( frd->IsTerminating() )
	{
		cf->m_ActiveFindDialog = NULL;
		return 0;
	}
	
	BOOL		doReplace = FALSE;
	if ( frd->ReplaceCurrent() )	doReplace = TRUE;
	FINDTEXTEX	ftex;
	DWORD		ff = 0;

	if ( frd->MatchCase() ) ff|=FR_MATCHCASE;
	if ( frd->MatchWholeWord() ) ff|=FR_WHOLEWORD;

	m_RichEdit.GetSel( ftex.chrg );

	if ( frd->SearchDown() )
	{
		ftex.chrg.cpMin = ftex.chrg.cpMax;
		ftex.chrg.cpMax = -1;
	} else {
		ftex.chrg.cpMax = ftex.chrg.cpMin;
		ftex.chrg.cpMin = 0;
	}

	CString	find_text = frd->GetFindString();
	m_csFindText = find_text;

	CString replace_text = frd->GetReplaceString();

	ftex.lpstrText = find_text.LockBuffer();
	int l = m_RichEdit.FindText( ff, &ftex );
	find_text.UnlockBuffer();

	if ( l == -1 ) 
	{ 
		::MessageBeep(0); 
		::MessageBox( HWND_DESKTOP, "No more occurances of search string found.", "Find/Replace", MB_OK|MB_ICONINFORMATION );
		return -1; 
	}

	m_RichEdit.SetSel( ftex.chrgText );

	if (doReplace)
	{
		m_RichEdit.ReplaceSel( replace_text.LockBuffer() );
		replace_text.UnlockBuffer();
		ftex.chrgText.cpMax = ftex.chrgText.cpMin + replace_text.GetLength();
		m_RichEdit.SetSel( ftex.chrgText );
	}

	return 0;
}

void CSourceView::OnPrint(CDC* pDC, CPrintInfo* pInfo) 
{
//	CView::OnPrint(pDC, pInfo);

	int nIndexStart = 0;
	int nIndexStop = -1;
	CSize m_sizePaper; m_sizePaper.cx = 8*1440+720; m_sizePaper.cy = 11*1440;
	CRect m_rectMargin = 0;

	FORMATRANGE fr;

	// offset by printing offset
	pDC->SetViewportOrg(-pDC->GetDeviceCaps(PHYSICALOFFSETX),
		-pDC->GetDeviceCaps(PHYSICALOFFSETY));
	// adjust DC because richedit doesn't do things like MFC
	if (::GetDeviceCaps(pDC->m_hDC, TECHNOLOGY) != DT_METAFILE && pDC->m_hAttribDC != NULL)
	{
		::ScaleWindowExtEx(pDC->m_hDC,
			::GetDeviceCaps(pDC->m_hDC, LOGPIXELSX),
			::GetDeviceCaps(pDC->m_hAttribDC, LOGPIXELSX),
			::GetDeviceCaps(pDC->m_hDC, LOGPIXELSY),
			::GetDeviceCaps(pDC->m_hAttribDC, LOGPIXELSY), NULL);
	}

	fr.hdcTarget = pDC->m_hAttribDC;
	fr.hdc = pDC->m_hDC;
	fr.rcPage = CRect(CPoint(0,0),m_sizePaper);
	fr.rc = CRect( m_rectMargin.left, m_rectMargin.top,m_sizePaper.cx-m_rectMargin.right,m_sizePaper.cy-m_rectMargin.bottom );

	fr.chrg.cpMin = nIndexStart;
	fr.chrg.cpMax = nIndexStop;
	long lRes = m_RichEdit.FormatRange(&fr,TRUE);
}


