// SourceView.h : interface of the CSourceView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_SourceView_H__6196176E_2F28_11D3_84C8_0080C80D45B8__INCLUDED_)
#define AFX_SourceView_H__6196176E_2F28_11D3_84C8_0080C80D45B8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "forge.h"
#include "inputbox1.h"

#define EDIT_MENU_IDX	1

class CSourceView;

class CSourceView : public CView
{
protected: // create from serialization only
	CSourceView();
	DECLARE_DYNCREATE(CSourceView)

// Attributes
public:
	CSourceDoc* GetDocument();

protected:
	void (CSourceView::*m_ActionXT)(int line, CString& cs);
// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSourceView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual void OnInitialUpdate();
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult);
	virtual void OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView);
	virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	CString m_csFindText;
	CString m_csReplaceText;
	BOOL bFullScreen;
	void ToEndOfSelection( void );
	void GetSelectedWord( CString &cs );
	virtual ~CSourceView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	LONG OnFindReplace( WPARAM wParam, LPARAM lParam );
	void WriteBack( void );
	void ActionForLines( int start, int end );
	void ACTION_Comment( int iLine, CString &cs );
	void LaunchContextMenu( int x, int y );
	CFont m_Font;
	COLORREF m_crMarginColor;
	int m_nMarginWidth;
	CRichEditCtrl m_RichEdit;
	//{{AFX_MSG(CSourceView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnPaint();
	afx_msg void OnEditCopy();
	afx_msg void OnUpdateEditCopy(CCmdUI* pCmdUI);
	afx_msg void OnEditCut();
	afx_msg void OnUpdateEditCut(CCmdUI* pCmdUI);
	afx_msg void OnEditPaste();
	afx_msg void OnUpdateEditPaste(CCmdUI* pCmdUI);
	afx_msg void OnEditUndo();
	afx_msg void OnUpdateEditUndo(CCmdUI* pCmdUI);
	afx_msg void OnEditComment();
	afx_msg void OnUpdateEditComment(CCmdUI* pCmdUI);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnEditSelectAll();
	afx_msg void OnUpdateEditSelectAll(CCmdUI* pCmdUI);
	afx_msg void OnEditGotoline();
	afx_msg void OnUpdateEditGotoline(CCmdUI* pCmdUI);
	afx_msg void OnViewFullscreen();
	afx_msg void OnUpdateViewFullscreen(CCmdUI* pCmdUI);
	afx_msg void OnEditRepeat();
	afx_msg void OnUpdateEditRepeat(CCmdUI* pCmdUI);
	afx_msg void OnEditReplace();
	afx_msg void OnUpdateEditReplace(CCmdUI* pCmdUI);
	afx_msg void OnEditFind();
	afx_msg void OnUpdateEditFind(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in SourceView.cpp
inline CSourceDoc* CSourceView::GetDocument()
   { return (CSourceDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SourceView_H__6196176E_2F28_11D3_84C8_0080C80D45B8__INCLUDED_)
